require("controls")
require("tiles")
require("funcs")
require("levels")
function love.load()
	KEYS = 0
	wallimg = love.graphics.newImage("walltile.png")
	keyimg = love.graphics.newImage("keytile.png")
	doorimg = love.graphics.newImage("locktile.png")
	zapimg = love.graphics.newImage("zaptile.png")
	nextimg = love.graphics.newImage("nextlevel.png")
	teleimg = love.graphics.newImage("teletile.png")
	portimg = love.graphics.newImage("porttile.png")
	signimg = love.graphics.newImage("signtile.png")
	keysnd = love.audio.newSource("pickupcoin.wav", static) -- Thanks for generating sounds, bfxr.net!
	doorsnd = love.audio.newSource("hithurt.wav", static)
	diesnd = love.audio.newSource("blipselect.wav", static)
	nextsnd = love.audio.newSource("powerup.wav", static)
	telesnd = love.audio.newSource("powerup2.wav", static)
	buttonFont = love.graphics.newFont(16)
	titleFont = love.graphics.newFont(32)
	SCREENMODE = 0
	CURRENTLEVEL = 1
	GAMESTATE = 0
	READINGSIGN = false
	doChangeLevel()
	LEVELDESC = "Mouse Game"
	table.insert(menuButtons, buttonz:New("Start Level", 64, 64, 128, 64, function () GAMESTATE = 1; doChangeLevel() end))
	table.insert(menuButtons, buttonz:New("Windowed", 192, 64, 128, 64, function () doChangeScreenMode() end))
	table.insert(menuButtons, buttonz:New("New Game", 448, 64, 128, 64, function () CURRENTLEVEL = 1; doChangeLevel(); LEVELDESC = "Progress Cleared" end))
	table.insert(menuButtons, buttonz:New("Exit", 576, 64, 128, 64, function () love.event.push("quit") end))
end
function love.update(dt)
	READINGSIGN = false
	if SCREENMODE == 1 then
		menuButtons[2].label = "Fullscreen"
	else
		menuButtons[2].label = "Windowed"
	end
	menuButtons[1].label = "Start Level "..CURRENTLEVEL
	if GAMESTATE == 1 then
		for k,v in pairs(walltiles) do
			v:update(dt)
		end
		for k,v in pairs(keytiles) do
			v:update(dt)
		end
		for k,v in pairs(doortiles) do
			v:update(dt)
		end
		for k,v in pairs(zaptiles) do
			v:update(dt)
		end
		for k,v in pairs(nexttiles) do
			v:update(dt)
		end
		for k,v in pairs(teletiles) do
			v:update(dt)
		end
		for k,v in pairs(porttiles) do
			v:update(dt)
		end
		for k,v in pairs(signtiles) do
			v:update(dt)
		end
	end
end
function love.draw()
	if GAMESTATE == 0  then
		for k,v in pairs(menuButtons) do
			v:draw()
		end
		love.graphics.setFont( titleFont)
		love.graphics.printf( LEVELDESC, 0, 368, 768, "center")
		for k,v in pairs(menuButtons) do
			v:draw()
		end
	end
	if GAMESTATE == 1 then
		for k,v in pairs(walltiles) do
			v:draw()
		end
		for k,v in pairs(keytiles) do
			v:draw()
		end
		for k,v in pairs(doortiles) do
			v:draw()
		end
		for k,v in pairs(zaptiles) do
			v:draw()
		end
		for k,v in pairs(nexttiles) do
			v:draw()
		end
		for k,v in pairs(teletiles) do
			v:draw()
		end
		for k,v in pairs(porttiles) do
			v:draw()
		end
		for k,v in pairs(signtiles) do
			v:draw()
		end
		if READINGSIGN then
			local putx, puty = love.mouse.getX(), love.mouse.getY() + 32
			if putx > 440 then
				putx = putx - 300
			end
			love.graphics.printf( LEVELSIGN, putx, puty, 300, "center")
		end
	end
end
function love.mousepressed(x, y, button)
	for k,v in pairs(menuButtons) do
		v:exe(x, y)
	end
end
function love.keypressed(key, unicode)
	if key == "escape" then love.event.push("quit") end
end